/*
 * gedit-code-listing-plugin-panel.h
 *
 * Copyright (C) 2005 - Jesse van den Kieboom
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */

#ifndef __GEDIT_CODE_LISTING_PLUGIN_PANEL_H__
#define __GEDIT_CODE_LISTING_PLUGIN_PANEL_H__

#include <gtk/gtk.h>
#include <gedit/gedit-window.h>

#define GPM_PLUGINS_DIR GPM_PREFS_DIR "/plugins"

G_BEGIN_DECLS

/*
 * Type checking and casting macros
 */
#define GEDIT_TYPE_CODE_LISTING_PLUGIN_PANEL              (gedit_code_listing_plugin_panel_get_type())
#define GEDIT_CODE_LISTING_PLUGIN_PANEL(obj)              (G_TYPE_CHECK_INSTANCE_CAST((obj), GEDIT_TYPE_CODE_LISTING_PLUGIN_PANEL, GeditCodeListingPluginPanel))
#define GEDIT_CODE_LISTING_PLUGIN_PANEL_CONST(obj)        (G_TYPE_CHECK_INSTANCE_CAST((obj), GEDIT_TYPE_CODE_LISTING_PLUGIN_PANEL, GeditCodeListingPluginPanel const))
#define GEDIT_CODE_LISTING_PLUGIN_PANEL_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST((klass), GEDIT_TYPE_CODE_LISTING_PLUGIN_PANEL, GeditCodeListingPluginPanelClass))
#define GEDIT_IS_CODE_LISTING_PLUGIN_PANEL(obj)           (G_TYPE_CHECK_INSTANCE_TYPE((obj), GEDIT_TYPE_CODE_LISTING_PLUGIN_PANEL))
#define GEDIT_IS_CODE_LISTING_PLUGIN_PANEL_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), GEDIT_TYPE_CODE_LISTING_PLUGIN_PANEL))
#define GEDIT_CODE_LISTING_PLUGIN_PANEL_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS((obj), GEDIT_TYPE_CODE_LISTING_PLUGIN_PANEL, GeditCodeListingPluginPanelClass))

/* Private structure type */
typedef struct _GeditCodeListingPluginPanelPrivate GeditCodeListingPluginPanelPrivate;

/*
 * Main object structure
 */
typedef struct _GeditCodeListingPluginPanel GeditCodeListingPluginPanel;

struct _GeditCodeListingPluginPanel 
{
	GtkVBox vbox;

	/*< private > */
	GeditCodeListingPluginPanelPrivate *priv;
};

/*
 * Class definition
 */
typedef struct _GeditCodeListingPluginPanelClass GeditCodeListingPluginPanelClass;

struct _GeditCodeListingPluginPanelClass 
{
	GtkVBoxClass parent_class;
};

/*
 * Public methods
 */
GType		 gedit_code_listing_plugin_panel_register_type	(GTypeModule *module);
							
GType 		 gedit_code_listing_plugin_panel_get_type		(void);

GtkWidget	*gedit_code_listing_plugin_panel_new 		(GeditWindow *window);

G_END_DECLS

#endif  /* __GEDIT_CODE_LISTING_PLUGIN_PANEL_H__  */
