/*
 * gedit-code-listing-plugin.h
 * 
 * Copyright (C) 2005 - Jesse van den Kieboom
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */

#ifndef __GEDIT_CODE_LISTING_PLUGIN_H__
#define __GEDIT_CODE_LISTING_PLUGIN_H__

#include <glib.h>
#include <glib-object.h>
#include <gedit/gedit-plugin.h>

G_BEGIN_DECLS

/*
 * Type checking and casting macros
 */
#define GEDIT_TYPE_CODE_LISTING_PLUGIN		(gedit_code_listing_plugin_get_type ())
#define GEDIT_CODE_LISTING_PLUGIN(o)		(G_TYPE_CHECK_INSTANCE_CAST ((o), GEDIT_TYPE_CODE_LISTING_PLUGIN, GeditCodeListingPlugin))
#define GEDIT_CODE_LISTING_PLUGIN_CLASS(k)	(G_TYPE_CHECK_CLASS_CAST((k), GEDIT_TYPE_CODE_LISTING_PLUGIN, GeditCodeListingPluginClass))
#define GEDIT_IS_CODE_LISTING_PLUGIN(o)		(G_TYPE_CHECK_INSTANCE_TYPE ((o), GEDIT_TYPE_CODE_LISTING_PLUGIN))
#define GEDIT_IS_CODE_LISTING_PLUGIN_CLASS(k)	(G_TYPE_CHECK_CLASS_TYPE ((k), GEDIT_TYPE_CODE_LISTING_PLUGIN))
#define GEDIT_CODE_LISTING_PLUGIN_GET_CLASS(o)	(G_TYPE_INSTANCE_GET_CLASS ((o), GEDIT_TYPE_CODE_LISTING_PLUGIN, GeditCodeListingPluginClass))

/* Private structure type */
typedef struct _GeditCodeListingPluginPrivate	GeditCodeListingPluginPrivate;

/*
 * Main object structure
 */
typedef struct _GeditCodeListingPlugin		GeditCodeListingPlugin;

struct _GeditCodeListingPlugin
{
	GeditPlugin parent_instance;

	/*< private >*/
	GeditCodeListingPluginPrivate *priv;
};

/*
 * Class definition
 */
typedef struct _GeditCodeListingPluginClass	GeditCodeListingPluginClass;

struct _GeditCodeListingPluginClass
{
	GeditPluginClass parent_class;
};

/*
 * Public methods
 */
GType	gedit_code_listing_plugin_get_type		(void);

/* All plugins must implement this function */
G_MODULE_EXPORT GType register_gedit_plugin (GTypeModule *module);

G_END_DECLS

#endif /* __GEDIT_CODE_LISTING_PLUGIN_H__ */
